;****************************************************************************************

;----------------------------------------------------------------------------------------
; Hasan Grlek 2002
;----------------------------------------------------------------------------------------

;****************************************************************************************

	LIST	P=16F877
	#INCLUDE 	C:\PROJE\P16F877.INC	


KOMUT	EQU	h'20'
KONTROL	EQU	h'21'
REGISTER_ADRESI	EQU	h'22'
SAYAC	EQU	h'23'
WREG_YED	EQU	h'24'
STATUS_YED	EQU	h'25'
PCLATH_YED	EQU	h'26'
ANALOG_HIGH	EQU	h'27'
ANALOG_LOW	EQU	h'28'
ADCON0_DATA	EQU	h'29'
ADCON1_DATA	EQU	h'2A'
SPRG_TANIM	EQU	h'2B'

#DEFINE	ADCON0_ALINACAK	KONTROL,0
#DEFINE	ADCON1_ALINACAK	KONTROL,1




;****************************************************************************************

;----------------------------------------------------------------------------------------
; Reset Baslama Noktasi ( S A Y F A   1 )
; Program baslama nedeni bu blmde tespit edilir.
;----------------------------------------------------------------------------------------


	ORG	h'0000'

	BTFSC	STATUS,NOT_TO
	B	SYSTEM_SETUP
	B	WDT_TEST


;****************************************************************************************
;----------------------------------------------------------------------------------------
; Kesme durumunda islenecek program kodlari.
;----------------------------------------------------------------------------------------

	ORG	h'0004'
	MOVWF	WREG_YED	; W REGISTERI YEDEKLIYOR.
	SWAPF	STATUS,W	; STATUS REGISTERI YEDEKLIYOR.
	CLRF	STATUS
	MOVWF	STATUS_YED
	MOVF 	PCLATH, W 	; PCLATH YEDEKLIYOR.
	MOVWF 	PCLATH_YED
	CLRF 	PCLATH
	B	INT_SERVIS


;----------------------------------------------------------------------------------------
; WDT zaman asimi nedeni ile reset meydana geldiyse program buraya ynlenir.
;----------------------------------------------------------------------------------------

WDT_TEST

	B	WDT_TEST
	
	
SYSTEM_SETUP

	MOVLW	.128
	MOVWF 	PORTB
	BANKSEL	TRISA
	MOVLW	b'10000110'
	MOVWF	ADCON1	; 
	MOVLW	b'00111111'
	MOVWF	TRISA
	MOVLW	b'00000000'
	MOVWF	TRISB
	MOVLW	b'11111111'
	MOVWF	TRISC
	MOVLW	b'11111111'
	MOVWF	TRISD
	MOVLW	b'00000111'
	MOVWF	TRISE
	BANKSEL	PORTA
	
;	BSF	T1CON,TMR1ON


	CALL	USART_SETUP
	CALL	USART_YUKLE
	
	MOVLW	b'11000000'
	MOVWF	INTCON	;
	
BEKLE
	B	BEKLE

;******************************************************************************************
USART_SETUP
	BTFSC	PORTC,0
	B	MHz3.6864
	
	BTFSC	PORTC,1
	B	MHz4
	
	BTFSC	PORTC,2
	B	MHz10

	BTFSC	PORTC,3
	B	MHz16
	
	BTFSC	PORTC,4
	B	MHz20
	
	B	MHz4


MHz3.6864
	BTFSC	PORTD,0
	B	BAUD03_MHz3.6864
	BTFSC	PORTD,1
	B	BAUD12_MHz3.6864	
	BTFSC	PORTD,2
	B	BAUD24_MHz3.6864
	BTFSC	PORTD,3
	B	BAUD96_MHz3.6864
	BTFSC	PORTD,4
	B	BAUD192_MHz3.6864
	BTFSC	PORTD,5
	B	BAUD288_MHz3.6864
	BTFSC	PORTD,6
	B	BAUD336_MHz3.6864
	BTFSC	PORTD,7
	B	BAUD576_MHz3.6864
MHz4
	BTFSC	PORTD,0
	B	BAUD03_MHz4
	BTFSC	PORTD,1
	B	BAUD12_MHz4
	BTFSC	PORTD,2
	B	BAUD24_MHz4
	BTFSC	PORTD,3
	B	BAUD96_MHz4
	BTFSC	PORTD,4
	B	BAUD192_MHz4
	BTFSC	PORTD,5
	B	BAUD288_MHz4
	BTFSC	PORTD,6
	B	BAUD336_MHz4
	BTFSC	PORTD,7
	B	BAUD576_MHz4
MHz10
	BTFSC	PORTD,0
	B	BAUD03_MHz10
	BTFSC	PORTD,1
	B	BAUD12_MHz10
	BTFSC	PORTD,2
	B	BAUD24_MHz10
	BTFSC	PORTD,3
	B	BAUD96_MHz10
	BTFSC	PORTD,4
	B	BAUD192_MHz10
	BTFSC	PORTD,5
	B	BAUD288_MHz10
	BTFSC	PORTD,6
	B	BAUD336_MHz10
	BTFSC	PORTD,7
	B	BAUD576_MHz10
MHz16
	BTFSC	PORTD,0
	B	BAUD03_MHz16
	BTFSC	PORTD,1
	B	BAUD12_MHz16
	BTFSC	PORTD,2
	B	BAUD24_MHz16
	BTFSC	PORTD,3
	B	BAUD96_MHz16
	BTFSC	PORTD,4
	B	BAUD192_MHz16
	BTFSC	PORTD,5
	B	BAUD288_MHz16
	BTFSC	PORTD,6
	B	BAUD336_MHz16
	BTFSC	PORTD,7
	B	BAUD576_MHz16
MHz20
	BTFSC	PORTD,0
	B	BAUD03_MHz20
	BTFSC	PORTD,1
	B	BAUD12_MHz20
	BTFSC	PORTD,2
	B	BAUD24_MHz20
	BTFSC	PORTD,3
	B	BAUD96_MHz20
	BTFSC	PORTD,4
	B	BAUD192_MHz20
	BTFSC	PORTD,5
	B	BAUD288_MHz20
	BTFSC	PORTD,6
	B	BAUD336_MHz20
	BTFSC	PORTD,7
	B	BAUD576_MHz20
	
;******************************************************************************************
BAUD03_MHz3.6864
	BTFSC	PORTC,5
	B	TANIMLAMA_HATASI
	MOVLW	.191
	MOVWF	SPRG_TANIM
	RETURN
BAUD12_MHz3.6864
	MOVLW	.47
	BTFSC	PORTC,5
	MOVLW	.191
	MOVWF	SPRG_TANIM
	RETURN
BAUD24_MHz3.6864
	MOVLW	.23
	BTFSC	PORTC,5
	MOVLW	.95
	MOVWF	SPRG_TANIM
	RETURN
BAUD96_MHz3.6864
	MOVLW	.5
	BTFSC	PORTC,5
	MOVLW	.23
	MOVWF	SPRG_TANIM
	RETURN

BAUD192_MHz3.6864
	MOVLW	.2
	BTFSC	PORTC,5
	MOVLW	.11
	MOVWF	SPRG_TANIM
	RETURN
BAUD288_MHz3.6864
	MOVLW	.1
	BTFSC	PORTC,5
	MOVLW	.7
	MOVWF	SPRG_TANIM
	RETURN
BAUD336_MHz3.6864
	BTFSS	PORTC,5
	B	TANIMLAMA_HATASI
	MOVLW	.6
	MOVWF	SPRG_TANIM
	RETURN
BAUD576_MHz3.6864
	MOVLW	.0
	BTFSC	PORTC,5
	MOVLW	.3
	MOVWF	SPRG_TANIM
	RETURN
;******************************************************************************************	
BAUD03_MHz4
	BTFSC	PORTC,5
	B	TANIMLAMA_HATASI
	MOVLW	.207
	MOVWF	SPRG_TANIM
	RETURN
BAUD12_MHz4
	MOVLW	.51
	BTFSC	PORTC,5
	MOVLW	.207
	MOVWF	SPRG_TANIM
	RETURN
BAUD24_MHz4
	MOVLW	.25
	BTFSC	PORTC,5
	MOVLW	.103
	MOVWF	SPRG_TANIM
	RETURN
BAUD96_MHz4
	MOVLW	.6
	BTFSC	PORTC,5
	MOVLW	.25
	MOVWF	SPRG_TANIM
	RETURN
BAUD192_MHz4
	MOVLW	.2
	BTFSC	PORTC,5
	MOVLW	.12
	MOVWF	SPRG_TANIM
	RETURN
BAUD288_MHz4
	MOVLW	.1
	BTFSC	PORTC,5
	MOVLW	.8
	MOVWF	SPRG_TANIM
	RETURN
BAUD336_MHz4
	BTFSS	PORTC,5
	B	TANIMLAMA_HATASI
	MOVLW	.6
	MOVWF	SPRG_TANIM
	RETURN
BAUD576_MHz4
	MOVLW	.0
	BTFSC	PORTC,5
	MOVLW	.3
	MOVWF	SPRG_TANIM
	RETURN
;******************************************************************************************

BAUD03_MHz10
	B	TANIMLAMA_HATASI
BAUD12_MHz10
	BTFSC	PORTC,5
	B	TANIMLAMA_HATASI
	MOVLW	.129
	MOVWF	SPRG_TANIM
	RETURN
BAUD24_MHz10
	MOVLW	.64
	BTFSC	PORTC,5
	MOVLW	.255
	MOVWF	SPRG_TANIM
	RETURN
BAUD96_MHz10
	MOVLW	.15
	BTFSC	PORTC,5
	MOVLW	.64
	MOVWF	SPRG_TANIM
	RETURN
BAUD192_MHz10
	MOVLW	.7
	BTFSC	PORTC,5
	MOVLW	.31
	MOVWF	SPRG_TANIM
	RETURN
BAUD288_MHz10
	MOVLW	.4
	BTFSC	PORTC,5
	MOVLW	.21
	MOVWF	SPRG_TANIM
	RETURN
BAUD336_MHz10
	MOVLW	.4
	BTFSC	PORTC,5
	MOVLW	.18
	MOVWF	SPRG_TANIM
	RETURN
BAUD576_MHz10
	MOVLW	.2
	BTFSC	PORTC,5
	MOVLW	.10
	MOVWF	SPRG_TANIM
	RETURN
;******************************************************************************************
BAUD03_MHz16
	B	TANIMLAMA_HATASI
BAUD12_MHz16
	BTFSC	PORTC,5
	B	TANIMLAMA_HATASI
	MOVLW	.207
	MOVWF	SPRG_TANIM
	RETURN
BAUD24_MHz16
	BTFSC	PORTC,5
	B	TANIMLAMA_HATASI
	MOVLW	.103
	MOVWF	SPRG_TANIM
	RETURN
BAUD96_MHz16
	MOVLW	.25
	BTFSC	PORTC,5
	MOVLW	.103
	MOVWF	SPRG_TANIM
	RETURN
BAUD192_MHz16
	MOVLW	.12
	BTFSC	PORTC,5
	MOVLW	.51
	MOVWF	SPRG_TANIM
	RETURN
BAUD288_MHz16
	MOVLW	.8
	BTFSC	PORTC,5
	MOVLW	.33
	MOVWF	SPRG_TANIM
	RETURN
BAUD336_MHz16
	MOVLW	.6
	BTFSC	PORTC,5
	MOVLW	.29
	MOVWF	SPRG_TANIM
	RETURN
BAUD576_MHz16
	MOVLW	.3
	BTFSC	PORTC,5
	MOVLW	.16
	MOVWF	SPRG_TANIM
	RETURN
;******************************************************************************************
BAUD03_MHz20
	B	TANIMLAMA_HATASI
BAUD12_MHz20
	BTFSC	PORTC,5
	B	TANIMLAMA_HATASI
	MOVLW	.255
	MOVWF	SPRG_TANIM
	RETURN
BAUD24_MHz20
	BTFSC	PORTC,5
	B	TANIMLAMA_HATASI
	MOVLW	.129
	MOVWF	SPRG_TANIM
	RETURN
BAUD96_MHz20
	MOVLW	.31
	BTFSC	PORTC,5
	MOVLW	.129
	MOVWF	SPRG_TANIM
	RETURN
BAUD192_MHz20
	MOVLW	.15
	BTFSC	PORTC,5
	MOVLW	.64
	MOVWF	SPRG_TANIM
	RETURN
BAUD288_MHz20
	MOVLW	.9
	BTFSC	PORTC,5
	MOVLW	.42
	MOVWF	SPRG_TANIM
	RETURN
BAUD336_MHz20
	MOVLW	.8
	BTFSC	PORTC,5
	MOVLW	.36
	MOVWF	SPRG_TANIM
	RETURN
BAUD576_MHz20
	MOVLW	.4
	BTFSC	PORTC,5
	MOVLW	.20
	MOVWF	SPRG_TANIM
	RETURN
;******************************************************************************************
TANIMLAMA_HATASI
	BCF	PORTB,7
	B	TANIMLAMA_HATASI	

;******************************************************************************************
USART_YUKLE
	BANKSEL	TRISA
	movlw	b'11000000'
	iorwf	TRISC,F
	BANKSEL	PORTA
	MOVF	SPRG_TANIM,W
	BANKSEL	TRISA
	movwf	SPBRG
	movlw	b'00100000'
	movwf	TXSTA

	BSF	PIE1,RCIE
	BANKSEL	PORTA
	movlw	b'10010000'
	movwf	RCSTA
	BCF	PIR1,TXIF
	RETURN




	

INT_SERVIS
	BTFSC	PIR1,RCIF
	B	USART_DATA_ALINDI
	
	B	INT_SERVIS_SONU

;******************************************************************************************
USART_DATA_ALINDI
	BCF	PIR1,RCIF
	MOVF	RCREG,W
	MOVWF	KOMUT

	BTFSC	ADCON0_ALINACAK
	B	ADCON0_AL
	BTFSC	ADCON1_ALINACAK
	B	ADCON1_AL
	
	MOVLW	.100
	SUBWF	KOMUT,W
	BTFSC	STATUS,Z
	B	ADC_AYAR_BASLA
	
	
;	MOVLW	.125
;	SUBWF	KOMUT,W
;	BTFSC	STATUS,Z
;	B	ADC_IPTAL
	
	MOVLW	.150
	SUBWF	KOMUT,W
	BTFSC	STATUS,Z
	B	ADC_CEVRIM
	
	MOVLW	.200
	SUBWF	KOMUT,W
	BTFSC	STATUS,Z
	B	TUM_OKU
	
	MOVLW	.170
	SUBWF	KOMUT,W
	BTFSC	STATUS,Z
	B	ILETISIM_KONTROL
	
	B	INT_SERVIS_SONU

USART_DATA_YOLLANDI
	B	INT_SERVIS_SONU

;******************************************************************************************
ADC_AYAR_BASLA
	CALL	USART_VERIGONDER

	BSF	ADCON0_ALINACAK
	B	INT_SERVIS_SONU
	
ADCON0_AL
	CALL	USART_VERIGONDER
	MOVF	KOMUT,W
	MOVWF	ADCON0_DATA
	MOVWF	ADCON0
	BCF	ADCON0_ALINACAK
	BSF	ADCON1_ALINACAK
	B	INT_SERVIS_SONU
	
;******************************************************************************************		
ADCON1_AL
	CALL	USART_VERIGONDER

	MOVF	KOMUT,W
	MOVWF	ADCON1_DATA
	BANKSEL	ADCON1
	MOVWF	ADCON1
	BANKSEL	PORTA

	BCF	ADCON1_ALINACAK
	B	INT_SERVIS_SONU
;******************************************************************************************
ADC_IPTAL
	CALL	USART_VERIGONDER
	
	MOVF	ADCON1,W
	BANKSEL	ADCON1
	MOVWF	ADCON1
	BANKSEL	PORTA
	
	MOVF	ADCON0,W
	MOVWF	ADCON0

	B	INT_SERVIS_SONU

;******************************************************************************************
ADC_CEVRIM
	CALL	USART_VERIGONDER
	
	MOVF	ADCON1_DATA,W
	BANKSEL	ADCON1
	MOVWF	ADCON1
	BANKSEL	PORTA
	
	MOVF	ADCON0_DATA,W
	MOVWF	ADCON0

	BSF	ADCON0,ADON	; CEVRIM DEVREDE
	
	MOVLW	.20
	MOVWF	KOMUT
	DECFSZ	KOMUT,F
	B	$-.1

	BSF	ADCON0,GO_DONE	; CEVRIME BASLA
	BTFSC	ADCON0,GO_DONE	; CEVRIM TAMAMLANDIMI ?
	B	$-1	; HAYIR
	BCF	ADCON0,ADON	; EVET, CEVRIM DEVRE DISI
	
	BANKSEL	ADRESL
	MOVF	ADRESL,W	; ADRESL OKU
	BANKSEL	PORTA
	MOVWF	ANALOG_LOW	

	MOVF	ADRESH,W	; ADRESH OKU
	MOVWF	ANALOG_HIGH

	MOVWF	KOMUT
	CALL	USART_VERIGONDER

	MOVF	ANALOG_LOW,W
	MOVWF	KOMUT
	CALL	USART_VERIGONDER

	B	INT_SERVIS_SONU
;******************************************************************************************
ILETISIM_KONTROL
	CALL	USART_VERIGONDER
	B	INT_SERVIS_SONU
;******************************************************************************************
TUM_OKU
	CALL	USART_VERIGONDER

	BANKSEL	ADCON0
	MOVF	ADCON0,W
	BANKSEL	PORTA
	MOVWF	KOMUT
	CALL	USART_VERIGONDER
	
	BANKSEL	ADCON1
	MOVF	ADCON1,W
	BANKSEL	PORTA
	MOVWF	KOMUT
	CALL	USART_VERIGONDER

	BANKSEL	ADRESH
	MOVF	ADRESH,W
	BANKSEL	PORTA
	MOVWF	KOMUT
	CALL	USART_VERIGONDER
	
	BANKSEL	ADRESL
	MOVF	ADRESL,W
	BANKSEL	PORTA
	MOVWF	KOMUT
	CALL	USART_VERIGONDER
	
	BANKSEL	CCP1CON
	MOVF	CCP1CON,W
	BANKSEL	PORTA
	MOVWF	KOMUT
	CALL	USART_VERIGONDER
	
	BANKSEL	CCP2CON
	MOVF	CCP2CON,W
	BANKSEL	PORTA
	MOVWF	KOMUT
	CALL	USART_VERIGONDER
	
	BANKSEL	CCPR1H
	MOVF	CCPR1H,W
	BANKSEL	PORTA
	MOVWF	KOMUT
	CALL	USART_VERIGONDER
	
	BANKSEL	CCPR1L
	MOVF	CCPR1L,W
	BANKSEL	PORTA
	MOVWF	KOMUT
	CALL	USART_VERIGONDER
	
	BANKSEL	CCPR2H
	MOVF	CCPR2H,W
	BANKSEL	PORTA
	MOVWF	KOMUT
	CALL	USART_VERIGONDER
	
	BANKSEL	CCPR2L
	MOVF	CCPR2L,W
	BANKSEL	PORTA
	MOVWF	KOMUT
	CALL	USART_VERIGONDER
	
	BANKSEL	EEADR
	MOVF	EEADR,W
	BANKSEL	PORTA
	MOVWF	KOMUT
	CALL	USART_VERIGONDER
	
	BANKSEL	EEADRH
	MOVF	EEADRH,W
	BANKSEL	PORTA
	MOVWF	KOMUT
	CALL	USART_VERIGONDER
	
	BANKSEL	EECON1
	MOVF	EECON1,W
	BANKSEL	PORTA
	MOVWF	KOMUT
	CALL	USART_VERIGONDER
	
	BANKSEL	EECON2
	MOVF	EECON2,W
	BANKSEL	PORTA
	MOVWF	KOMUT
	CALL	USART_VERIGONDER
	
	BANKSEL	EEDATA
	MOVF	EEDATA,W
	BANKSEL	PORTA
	MOVWF	KOMUT
	CALL	USART_VERIGONDER
	
	BANKSEL	EEDATH
	MOVF	EEDATH,W
	BANKSEL	PORTA
	MOVWF	KOMUT
	CALL	USART_VERIGONDER
	
	BANKSEL	FSR
	MOVF	FSR,W
	BANKSEL	PORTA
	MOVWF	KOMUT
	CALL	USART_VERIGONDER
	
	BANKSEL	INDF
	MOVF	INDF,W
	BANKSEL	PORTA
	MOVWF	KOMUT
	CALL	USART_VERIGONDER

	BANKSEL	INTCON
	MOVF	INTCON,W
	BANKSEL	PORTA
	MOVWF	KOMUT
	CALL	USART_VERIGONDER
	
	BANKSEL	OPTION_REG
	MOVF	OPTION_REG,W
	BANKSEL	PORTA
	MOVWF	KOMUT
	CALL	USART_VERIGONDER
	
	BANKSEL	PCL
	MOVF	PCL,W
	BANKSEL	PORTA
	MOVWF	KOMUT
	CALL	USART_VERIGONDER
	
	BANKSEL	PCLATH
	MOVF	PCLATH,W
	BANKSEL	PORTA
	MOVWF	KOMUT
	CALL	USART_VERIGONDER
	
	BANKSEL	PCON
	MOVF	PCON,W
	BANKSEL	PORTA
	MOVWF	KOMUT
	CALL	USART_VERIGONDER
	
	BANKSEL	PIE1
	MOVF	PIE1,W
	BANKSEL	PORTA
	MOVWF	KOMUT
	CALL	USART_VERIGONDER
	
	BANKSEL	PIE2
	MOVF	PIE2,W
	BANKSEL	PORTA
	MOVWF	KOMUT
	CALL	USART_VERIGONDER
	
	BANKSEL	PIR1
	MOVF	PIR1,W
	BANKSEL	PORTA
	MOVWF	KOMUT
	CALL	USART_VERIGONDER
	
	BANKSEL	PIR2
	MOVF	PIR2,W
	BANKSEL	PORTA
	MOVWF	KOMUT
	CALL	USART_VERIGONDER
	
	BANKSEL	PORTA
	MOVF	PORTA,W
	BANKSEL	PORTA
	MOVWF	KOMUT
	CALL	USART_VERIGONDER
	
	BANKSEL	PORTB
	MOVF	PORTB,W
	BANKSEL	PORTA
	MOVWF	KOMUT
	CALL	USART_VERIGONDER
	
	BANKSEL	PORTC
	MOVF	PORTC,W
	BANKSEL	PORTA
	MOVWF	KOMUT
	CALL	USART_VERIGONDER
	
	BANKSEL	PORTD
	MOVF	PORTD,W
	BANKSEL	PORTA
	MOVWF	KOMUT
	CALL	USART_VERIGONDER
	
	BANKSEL	PORTE
	MOVF	PORTE,W
	BANKSEL	PORTA
	MOVWF	KOMUT
	CALL	USART_VERIGONDER
	
	BANKSEL	PR2
	MOVF	PR2,W
	BANKSEL	PORTA
	MOVWF	KOMUT
	CALL	USART_VERIGONDER
	
	BANKSEL	RCREG
	MOVF	RCREG,W
	BANKSEL	PORTA
	MOVWF	KOMUT
	CALL	USART_VERIGONDER
	
	BANKSEL	RCSTA
	MOVF	RCSTA,W
	BANKSEL	PORTA
	MOVWF	KOMUT
	CALL	USART_VERIGONDER
	
	BANKSEL	SSPADD
	MOVF	SSPADD,W
	BANKSEL	PORTA
	MOVWF	KOMUT
	CALL	USART_VERIGONDER
	
	BANKSEL	SSPBUF
	MOVF	SSPBUF,W
	BANKSEL	PORTA
	MOVWF	KOMUT
	CALL	USART_VERIGONDER
	
	BANKSEL	SSPCON
	MOVF	SSPCON,W
	BANKSEL	PORTA
	MOVWF	KOMUT
	CALL	USART_VERIGONDER
	
	BANKSEL	SSPCON2
	MOVF	SSPCON2,W
	BANKSEL	PORTA
	MOVWF	KOMUT
	CALL	USART_VERIGONDER
	
	BANKSEL	SSPSTAT
	MOVF	SSPSTAT,W
	BANKSEL	PORTA
	MOVWF	KOMUT
	CALL	USART_VERIGONDER
	
	BANKSEL	STATUS
	MOVF	STATUS,W
	BANKSEL	PORTA
	MOVWF	KOMUT
	CALL	USART_VERIGONDER
	
	BANKSEL	T1CON
	MOVF	T1CON,W
	BANKSEL	PORTA
	MOVWF	KOMUT
	CALL	USART_VERIGONDER
	
	BANKSEL	T2CON
	MOVF	T2CON,W
	BANKSEL	PORTA
	MOVWF	KOMUT
	CALL	USART_VERIGONDER
	
	BANKSEL	TMR0
	MOVF	TMR0,W
	BANKSEL	PORTA
	MOVWF	KOMUT
	CALL	USART_VERIGONDER
	
	BANKSEL	TMR1H
	MOVF	TMR1H,W
	BANKSEL	PORTA
	MOVWF	KOMUT
	CALL	USART_VERIGONDER
	
	BANKSEL	TMR1L
	MOVF	TMR1L,W
	BANKSEL	PORTA
	MOVWF	KOMUT
	CALL	USART_VERIGONDER
	
	BANKSEL	TMR2
	MOVF	TMR2,W
	BANKSEL	PORTA
	MOVWF	KOMUT
	CALL	USART_VERIGONDER
	
	BANKSEL	TRISA
	MOVF	TRISA,W
	BANKSEL	PORTA
	MOVWF	KOMUT
	CALL	USART_VERIGONDER
	
	BANKSEL	TRISB
	MOVF	TRISB,W
	BANKSEL	PORTA
	MOVWF	KOMUT
	CALL	USART_VERIGONDER
	
	BANKSEL	TRISC
	MOVF	TRISC,W
	BANKSEL	PORTA
	MOVWF	KOMUT
	CALL	USART_VERIGONDER
	
	BANKSEL	TRISD
	MOVF	TRISD,W
	BANKSEL	PORTA
	MOVWF	KOMUT
	CALL	USART_VERIGONDER
	
	BANKSEL	TRISE
	MOVF	TRISE,W
	BANKSEL	PORTA
	MOVWF	KOMUT
	CALL	USART_VERIGONDER
	
	BANKSEL	TXREG
	MOVF	TXREG,W
	BANKSEL	PORTA
	MOVWF	KOMUT
	CALL	USART_VERIGONDER

	BANKSEL	TXSTA
	MOVF	TXSTA,W
	BANKSEL	PORTA
	MOVWF	KOMUT
	CALL	USART_VERIGONDER
	
	BANKSEL	PORTA
	MOVF	WREG_YED,W
	MOVWF	KOMUT
	CALL	USART_VERIGONDER
	
	MOVF	STATUS_YED,W
	MOVWF	KOMUT
	CALL	USART_VERIGONDER
	
	MOVF	PCLATH_YED,W
	MOVWF	KOMUT
	CALL	USART_VERIGONDER
	
	B	INT_SERVIS_SONU
;******************************************************************************************
USART_VERIGONDER
	MOVF	KOMUT,W
	MOVWF	TXREG
	
	BANKSEL	TXSTA
	BTFSS	TXSTA,TRMT
	B	$-.1
	BANKSEL	PORTA

	RETURN

;******************************************************************************************
INT_SERVIS_SONU
	MOVF 	PCLATH_YED, W 	; PCLATH GERI YKLYOR.
	MOVWF 	PCLATH 

	SWAPF	STATUS_YED,W	; STATUS REGISTERI GERI YKLYOR.
	MOVWF	STATUS
	SWAPF	WREG_YED,F	; W REGISTERI GERI YKLYOR.
	SWAPF	WREG_YED,W
	RETFIE

	END
